Attribute VB_Name = "MdlPublic"

Option Explicit

Private Type MungeLong
   x        As Long
   Dummy    As Integer
End Type
 
Private Type MungeInt
   XLo      As Integer
   XHi      As Integer
   Dummy    As Integer
End Type
 
Private Declare Function CommandLineToArgv Lib "shell32" Alias "CommandLineToArgvW" (ByVal lpCmdLine As String, pNumArgs As Integer) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (dest As Any, src As Any, ByVal Size&)
Private Declare Function PtrToStr Lib "kernel32" Alias "lstrcpyW" (RetVal As Byte, ByVal Ptr As Long) As Long
Private Declare Function PtrToInt Lib "kernel32" Alias "lstrcpynW" (RetVal As Any, ByVal Ptr As Long, ByVal nCharCount As Long) As Long
Private Declare Function StrLen Lib "kernel32" Alias "lstrlenW" (ByVal Ptr As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
'--------
Private Declare Function GdiplusStartup Lib "gdiplus" (Token As Long, inputbuf As GdiplusStartupInput, Optional ByVal outputbuf As Long = 0) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal Token As Long)
Private Declare Function GdipDisposeImage Lib "gdiplus" (ByVal Image As Long) As Long
Private Declare Function GdipCreateFromHDC Lib "gdiplus" (ByVal hDC As Long, hGraphics As Long) As Long
Private Declare Function GdipDeleteGraphics Lib "gdiplus" (ByVal hGraphics As Long) As Long
Private Declare Function GdipGetImageBounds Lib "GdiPlus.dll" (ByVal nImage As Long, srcRect As RECTF, srcUnit As Long) As Long
Private Declare Function GdipDrawImageRect Lib "GdiPlus.dll" (ByVal mGraphics As Long, ByVal mImage As Long, ByVal mX As Single, ByVal mY As Single, ByVal mWidth As Single, ByVal mHeight As Single) As Long
Private Declare Function GdipLoadImageFromFile Lib "GdiPlus.dll" (ByVal mFilename As Long, ByRef mImage As Long) As Long
'--------
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Sub InitCommonControls Lib "comctl32.dll" ()
'--------
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hWndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
'-----

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const WM_CHANGEUISTATE As Long = &H127
Private Const UIS_HideRectangle As Integer = &H1
Private Const UIS_ShowRectangle As Integer = &H2
Private Const UISF_FocusRectangle As Integer = &H1
'----------
Private Declare Function DestroyIcon Lib "user32.dll" (ByVal hIcon As Long) As Long
Private Declare Function LoadImage Lib "user32.dll" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long

Private Const LR_LOADMAP3DCOLORS            As Long = &H1000
Private Const LR_SHARED                     As Long = &H8000&
Private Const IMAGE_ICON = 1
Private Const WM_GETICON As Long = &H7F
Private Const WM_SETICON As Long = &H80
Private Const ICON_BIG As Long = 1
Private Const ICON_SMALL As Long = 0



Private Type SHITEMID
    cb As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As SHITEMID
End Type

Private Type GdiplusStartupInput
    GdiplusVersion              As Long
    DebugEventCallback          As Long
    SuppressBackgroundThread    As Long
    SuppressExternalCodecs      As Long
End Type

Private Type RECTF
    nLeft                       As Single
    nTop                        As Single
    nWidth                      As Single
    nHeight                     As Single
End Type

Private Const QualityModeHigh                       As Long = 2&
Private Const InterpolationModeNearestNeighbor      As Long = QualityModeHigh + 3
Private Const PixelOffsetModeHalf                   As Long = QualityModeHigh + 2
Private Const UnitPixel                             As Long = &H2&

Enum eCSIDL_SPECIAL_FOLDERS
    e_ADMINTOOLS = &H30
    e_ALTSTARTUP = &H1D
    e_APPDATA = &H1A
    e_BITBUCKET = &HA
    e_COMMON_ADMINTOOLS = &H2F
    e_COMMON_ALTSTARTUP = &H1E
    e_COMMON_APPDATA = &H23
    e_COMMON_DESKTOPDIRECTORY = &H19
    e_COMMON_DOCUMENTS = &H2E
    e_COMMON_FAVORITES = &H1F
    e_COMMON_PROGRAMS = &H17
    e_COMMON_STARTMENU = &H16
    e_COMMON_STARTUP = &H18
    e_COMMON_TEMPLATES = &H2D
    e_CONNECTIONS = &H31
    e_CONTROLS = &H3
    e_COOKIES = &H21
    e_DESKTOP = &H0
    e_DESKTOPDIRECTORY = &H10
    e_DRIVES = &H11
    e_FAVORITES = &H6
    e_FLAG_DONT_VERIFY = &H4000
    e_FLAG_MASK = &HFF00&
    e_FLAG_PFTI_TRACKTARGET = e_FLAG_DONT_VERIFY
    e_FONTS = &H14
    e_INTERNET = &H1
    e_HISTORY = &H22
    e_INTERNET_CACHE = &H20
    e_LOCAL_APPDATA = &H1C
    e_MYPICTURES = &H27
    e_NETHOOD = &H13
    e_NETWORK = &H12
    e_PERSONAL = &H5
    e_PRINTERS = &H4
    e_PRINTHOOD = &H1B
    e_PROFILE = &H28
    e_PROGRAM_FILES = &H26
    e_PROGRAM_FILES_COMMON = &H2B
    e_PROGRAM_FILES_COMMONX86 = &H2C
    e_PROGRAM_FILESX86 = &H2A
    e_PROGRAMS = &H2
    e_RECENT = &H8
    e_SENDTO = &H9
    e_STARTMENU = &HB
    e_STARTUP = &H7
    e_SYSTEM = &H25
    e_SYSTEMX86 = &H29
    e_TEMPLATES = &H15
    e_WINDOWS = &H24
End Enum

'//For Action parameter in EncryptString
Public Const ENCRYPT = 1
Public Const DECRYPT = 2

Public m_sUser                  As String
Public m_sID                    As String
Public m_sPostFormID            As String
Public m_fb_dtsg                As String
Public m_Shell32                As Long

Public Const MY_KEY             As String = "ServerKey"
Public Const DELIMITER          As String = "|#|"

Public Type tPhotoAlbum
    sName                       As String
    sID                         As String
    sNumber                     As String
    sDate                       As String
End Type

Public cAlbumID                 As Collection
Public tAlbum()                 As tPhotoAlbum


Public Sub MyMsgbox(ByVal sMsg As String, Optional ByVal sTitle As String)
    FrmMsgBox.LblTitulo = sTitle
    FrmMsgBox.LblMsg = sMsg
    FrmMsgBox.Show vbModal
End Sub


Public Function DrawThumbNail(ByVal hDC As Long, ByVal sFilePath As String, ByVal lWidth As Long, ByVal lHeight As Long, Optional OrigWidth As Long, Optional OrigHeight)

    Dim hImage                  As Long
    Dim gdiSI                   As GdiplusStartupInput
    Dim gToken                  As Long
    Dim hGraphics               As Long
    Dim tRECTF                  As RECTF
    Dim PLeft                   As Double
    Dim PTop                    As Double
    Dim ReqWidth                As Long, ReqHeight As Long
    Dim HScale                  As Double, VScale As Double
    Dim MyScale                 As Double
    
    gdiSI.GdiplusVersion = 1&
    
    GdiplusStartup gToken, gdiSI
    
    If gToken <> 0 Then
        If GdipLoadImageFromFile(StrPtr(sFilePath), hImage) = 0 Then
            If GdipCreateFromHDC(hDC, hGraphics) = 0 Then
            
                GdipGetImageBounds hImage, tRECTF, UnitPixel
                OrigWidth = tRECTF.nWidth
                OrigHeight = tRECTF.nHeight
                HScale = lWidth / tRECTF.nWidth
                VScale = lHeight / tRECTF.nHeight
                    
                MyScale = IIf(VScale >= HScale, HScale, VScale)
                    
                ReqWidth = tRECTF.nWidth * MyScale
                ReqHeight = tRECTF.nHeight * MyScale
                    
                PLeft = (lWidth - ReqWidth) / 2
                PTop = (lHeight - ReqHeight) / 2
                
                Call GdipDrawImageRect(hGraphics, hImage, PLeft, PTop, ReqWidth, ReqHeight)
                GdipDeleteGraphics hGraphics
            End If
            GdipDisposeImage hImage
        End If
        GdiplusShutdown gToken
    End If
    
End Function


Public Function ParseCommandLine(ByVal sCommandLine As String) As String()
   Dim BufPtr               As Long
   Dim lNumArgs             As Integer
   Dim i                    As Long
   Dim lRes                 As Long
   Dim TempPtr              As MungeLong
   Dim TempStr              As MungeInt
   Dim ArgArray(512)        As Byte
   Dim Arg                  As String
   Dim Args()               As String
 
   BufPtr = CommandLineToArgv(StrConv(sCommandLine, vbUnicode), lNumArgs)
   ReDim Args(lNumArgs - 1)
 
   For i = 1 To lNumArgs
       lRes = PtrToInt(TempStr.XLo, BufPtr + (i - 1) * 4, 2)
       lRes = PtrToInt(TempStr.XHi, BufPtr + (i - 1) * 4 + 2, 2)
       LSet TempPtr = TempStr
       lRes = PtrToStr(ArgArray(0), TempPtr.x)
       Arg = Left(ArgArray, StrLen(TempPtr.x))
       Args(i - 1) = Arg
   Next i
 
   Call GlobalFree(BufPtr)
   ParseCommandLine = Args
End Function

 
Public Function IsEmptyArray(TestArray As Variant) As Boolean
   Dim lTemp As Long
   On Error GoTo ErrHandler
   lTemp = LBound(TestArray)
   IsEmptyArray = False
   Exit Function
ErrHandler:
   IsEmptyArray = True
End Function

Public Function CreateShortCut(ByVal TargetPath As String, ByVal ShortCutPath As String, ByVal ShortCutname As String, Optional ByVal WorkPath As String, Optional ByVal Window_Style As Integer, Optional ByVal IconNum As Integer) As Boolean
    On Error GoTo FalilCreateShortCut
    Dim MyShortcut As Object
    Dim VbsObj As Object
    
    Set VbsObj = CreateObject("WScript.Shell")
    
    'ShortCutPath = VbsObj.SpecialFolders(ShortCutPath)
    Set MyShortcut = VbsObj.CreateShortCut(ShortCutPath & "\" & ShortCutname & ".lnk")
    With MyShortcut
        .TargetPath = TargetPath
        .WorkingDirectory = WorkPath
        .WindowStyle = Window_Style
        .IconLocation = TargetPath & "," & IconNum
        .Save
    End With
    CreateShortCut = True
    Exit Function
FalilCreateShortCut:

End Function

' -------------------------------------------------------------------------------
Function GetSpecialFolder(SpecialFolder As eCSIDL_SPECIAL_FOLDERS) As String

    Dim lRet         As Long
    Dim IDL          As ITEMIDLIST
    Dim sPath        As String

    ' -- Obtener el ID del path
    lRet = SHGetSpecialFolderLocation(0&, SpecialFolder, IDL)

    If lRet = 0 Then
            ' -- Crear Buffer de caracteres para el path
            sPath$ = Space$(512)
            ' -- Recuperamos el path desde el ID
            lRet = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal sPath$)
            ' -- Eliminr nulos y retornar
            GetSpecialFolder = Left$(sPath, InStr(sPath, Chr$(0)) - 1)
    End If
End Function


Public Sub ForceWindowToShowAllUIStates(ByVal hwnd As Long)
    Call SendMessage(hwnd, WM_CHANGEUISTATE, MakeLong(UIS_HideRectangle, UISF_FocusRectangle), ByVal 0)
    Call SendMessage(hwnd, WM_CHANGEUISTATE, MakeLong(UIS_ShowRectangle, UISF_FocusRectangle), ByVal 0)
End Sub


Private Function MakeLong(ByVal wLow As Integer, ByVal wHigh As Integer) As Long
    MakeLong = wHigh * &H10000 + wLow
End Function


Public Function AddToContextualMenu() As Boolean
    Dim cRegistry As clsRegistry
    Set cRegistry = New clsRegistry
    Dim sKey As String
    Dim sMyPath As String
    
    sKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\*\shell\Enviar a Facebook"
    sMyPath = Chr$(34) & App.path & "\" & App.EXEName & ".exe" & Chr$(34)
    
    If cRegistry.CreateKey(sKey & "\command") Then
        AddToContextualMenu = cRegistry.WriteValue(sKey & "\command", vbNullString, sMyPath & " " & Chr$(34) & "%1" & Chr$(34))
        Call cRegistry.CreateValue(sKey, "Icon", REG_SZ)
        Call cRegistry.WriteValue(sKey, "Icon", sMyPath)
    End If
End Function

Public Function RemoveInContextualMenu() As Boolean
    Dim cRegistry As clsRegistry
    Set cRegistry = New clsRegistry
    Dim sKey As String
    
    sKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\*\shell\Enviar a Facebook"
    
    If cRegistry.KeyExists(sKey) Then
        If cRegistry.KillKey(sKey) Then
            RemoveInContextualMenu = True
        End If
    End If
End Function

Public Function IsInContextualMenu() As Boolean
    Dim cRegistry As clsRegistry
    Set cRegistry = New clsRegistry
    Dim sKey As String
    
    sKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\*\shell\Enviar a Facebook"
    
    If cRegistry.KeyExists(sKey) Then
        IsInContextualMenu = True
    End If
End Function

Public Sub PutIcon32Bit(ByVal hwnd As Long, ResIcon As Variant)
    Dim hIcon As Long
    hIcon = LoadImage(App.hInstance, ResIcon, IMAGE_ICON, 32, 32, LR_SHARED Or LR_LOADMAP3DCOLORS)
    If hIcon Then DestroyIcon SendMessage(hwnd, WM_SETICON, ICON_BIG, ByVal hIcon)
    hIcon = LoadImage(App.hInstance, ResIcon, IMAGE_ICON, 16, 16, LR_SHARED Or LR_LOADMAP3DCOLORS)
    If hIcon Then DestroyIcon SendMessage(hwnd, WM_SETICON, ICON_SMALL, ByVal hIcon)
End Sub



'---------------------------------------------------------------------
' EncryptString
' Modificado por Harvey T.
'---------------------------------------------------------------------

Public Function EncryptString(UserKey As String, Text As String, Action As Single) As String
    Dim UserKeyX As String
    Dim Temp     As Integer
    Dim Times    As Integer
    Dim i        As Integer
    Dim j        As Integer
    Dim n        As Integer
    Dim rtn      As String
    
    '//Get UserKey characters
    n = Len(UserKey)
    ReDim UserKeyASCIIS(1 To n)
    For i = 1 To n
        UserKeyASCIIS(i) = Asc(Mid$(UserKey, i, 1))
    Next
        
    '//Get Text characters
    ReDim TextASCIIS(Len(Text)) As Integer
    For i = 1 To Len(Text)
        TextASCIIS(i) = Asc(Mid$(Text, i, 1))
    Next
    
    '//Encryption/Decryption
    If Action = ENCRYPT Then
       For i = 1 To Len(Text)
           j = IIf(j + 1 >= n, 1, j + 1)
           Temp = TextASCIIS(i) + UserKeyASCIIS(j)
           If Temp > 255 Then
              Temp = Temp - 255
           End If
           rtn = rtn + Chr$(Temp)
       Next
    ElseIf Action = DECRYPT Then
       For i = 1 To Len(Text)
           j = IIf(j + 1 >= n, 1, j + 1)
           Temp = TextASCIIS(i) - UserKeyASCIIS(j)
           If Temp < 0 Then
              Temp = Temp + 255
           End If
           rtn = rtn + Chr$(Temp)
       Next
    End If
    
    '//Return
    EncryptString = rtn
End Function

