VERSION 5.00
Begin VB.Form FrmMain 
   Caption         =   "WinHTTPRequest"
   ClientHeight    =   1155
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   1740
   Icon            =   "FrmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1155
   ScaleWidth      =   1740
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.Timer Timer1 
      Left            =   600
      Top             =   240
   End
End
Attribute VB_Name = "FrmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

' ------------------------------------------------------------------
' Autor:        Leandro I. Ascierto
' Web:          www.leandroascierto.com.ar
' Fecha:        08 de Marzo de 2011
' Descripcin:  Ejecutable encargado de realizar las peticiones HTTP
'               del proyecto Facebook Photo Uploader.
' ------------------------------------------------------------------

Private Declare Function SetErrorMode Lib "kernel32.dll" (ByVal wMode As Long) As Long
Private Const SEM_NOGPFAULTERRORBOX As Long = &H2

Private WithEvents cDDE     As clsDDE
Attribute cDDE.VB_VarHelpID = -1


Private Sub Form_Load()
    Set cDDE = New clsDDE
    SetErrorMode SEM_NOGPFAULTERRORBOX
    
    mdlINI.FileName = App.Path & "\Conf.ini"
    
    If Command$ <> vbNullString Then
        Timer1.Interval = 10
    Else
        Unload Me
    End If
End Sub

Private Sub cDDE_ConnectionClose(ByVal hwnd As Long)
    Unload Me
End Sub

Private Function LoginUser(ByVal sMail As String, ByVal sPass As String) As Boolean
    If LogIn(sMail, sPass) Then
       
        If GetIDAndFormID(m_sID, m_sPostFormID, m_fb_dtsg) Then
            m_sUser = GetUserName(m_sID)
            If m_sUser <> vbNullString Then
                LoginUser = True
            End If
        End If
    End If
End Function

Private Function GetCurrentUser() As Boolean
        If GetIDAndFormID(m_sID, m_sPostFormID, m_fb_dtsg) Then
            m_sUser = GetUserName(m_sID)
            If m_sUser <> vbNullString Then
                GetCurrentUser = True
            End If
        End If
End Function


Private Sub Timer1_Timer()
    Dim sData() As String
    Dim sAlbums As String
    Dim sAlbumID As String
  
    Timer1.Interval = 0
    
    If cDDE.Join(SERVER_KEY) = True Then
        
        sData = Split(Command$, DELIMITER)
        
        Select Case sData(0)
            Case "LOGIN"
                If LoginUser(sData(1), sData(2)) Then
                    cDDE.SendData cDDE.hwndSever, "LOGIN_OK" & DELIMITER & m_sUser & DELIMITER & m_sID & DELIMITER & m_sPostFormID & DELIMITER & m_fb_dtsg
                Else
                    cDDE.SendData cDDE.hwndSever, "LOGIN_ERROR" & DELIMITER
                End If
                Unload Me
                
            Case "LOGOUT"
                Call LogOut
                Unload Me
                
            Case "GET_ALBUMS"
                sAlbums = GetAlbums()
                If sAlbums <> vbNullString Then
                    cDDE.SendData cDDE.hwndSever, "ALBUMS_OK" & DELIMITER & sAlbums
                Else
                    cDDE.SendData cDDE.hwndSever, "ALBUMS_ERROR" & DELIMITER
                End If
                Unload Me
                
            Case "UPLOAD_PHOTO"
                m_sID = sData(1)
                m_sPostFormID = sData(2)

                If UploadPhotoFacebook(sData(3), sData(4)) Then
                    cDDE.SendData cDDE.hwndSever, "UPLOAD_PHOTO_OK" & DELIMITER & sData(5)
                Else
                    cDDE.SendData cDDE.hwndSever, "UPLOAD_PHOTO_ERROR" & DELIMITER & sData(5)
                End If
                Unload Me
                
            Case "CREATE_ALBUM"
                sAlbumID = CreateAlbum(sData(1), sData(2), sData(3), sData(4), sData(5), sData(6))
                If sAlbumID <> "" Then
                    cDDE.SendData cDDE.hwndSever, "CREATE_ALBUM_OK" & DELIMITER & sAlbumID
                Else
                    cDDE.SendData cDDE.hwndSever, "CREATE_ALBUM_ERROR" & DELIMITER & sAlbumID
                End If
                Unload Me
                
            Case "IS_SOME_USER_LOGIN"
                If IsSomeUserLogin() Then
                    If GetCurrentUser Then
                        cDDE.SendData cDDE.hwndSever, "CURRENT_USER" & DELIMITER & m_sUser & DELIMITER & m_sID & DELIMITER & m_sPostFormID & DELIMITER & m_fb_dtsg
                    Else
                        cDDE.SendData cDDE.hwndSever, "NOT_ACTIVE_USER" & DELIMITER
                    End If
                Else
                    cDDE.SendData cDDE.hwndSever, "NOT_ACTIVE_USER" & DELIMITER
                End If
                Unload Me
                
            Case "PUBLISH_COMENT"
                PublishComent sData(1), sData(2), sData(3)
                Unload Me
            
        End Select

    Else
        Unload Me
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    cDDE.Disconnect
    Set cDDE = Nothing
End Sub
