Attribute VB_Name = "mdlFunctions"
Option Explicit

' ------------------------------------------------------------------
' Autor:        Leandro I. Ascierto
' Web:          www.leandroascierto.com.ar
' Fecha:        08 de Marzo de 2011
' Descripcin:  Ejecutable encargado de realizar las peticiones HTTP
'               del proyecto Facebook Photo Uploader.
' ------------------------------------------------------------------

Public m_sUser              As String
Public m_sID                As String
Public m_sPostFormID        As String
Public m_fb_dtsg            As String

Public Const SERVER_KEY     As String = "ServerKey"
Public Const DELIMITER      As String = "|#|"

Public Type tPhotoAlbum
    sName                   As String
    sID                     As String
    sNumber                 As String
    sDate                   As String
End Type

Public tAlbum() As tPhotoAlbum

Public Function LogOut()
    Call GetCode("http://m.facebook.com/logout.php")
End Function


Public Function LogIn(ByVal sMail As String, ByVal sPass As String) As Boolean
    Dim hInternetOpen           As Long
    Dim hInternetConnect        As Long
    Dim hHttpOpenRequest        As Long
    Dim bResult                 As Boolean
    Dim sReadBuffer             As String * 1024
    Dim sBuffer                 As String
    Dim lNumberOfBytesRead      As Long

    Call GetCode("http://m.facebook.com/logout.php")

    hInternetOpen = InternetOpen(USER_AGENT, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
    
    
    If hInternetOpen Then
    
        'InternetSetOption hInternetOpen, INTERNET_OPTION_CONNECT_TIMEOUT, TIME_OUT, 4
        'InternetSetOption hInternetOpen, INTERNET_OPTION_RECEIVE_TIMEOUT, TIME_OUT, 4
        'InternetSetOption hInternetOpen, INTERNET_OPTION_SEND_TIMEOUT, TIME_OUT, 4
        
    
        hInternetConnect = InternetConnect(hInternetOpen, "login.facebook.com", INTERNET_DEFAULT_HTTPS_PORT, vbNullString, "HTTP/1.1", INTERNET_SERVICE_HTTP, 0, 0)
    
    
        If hInternetConnect Then
        
            hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "POST", "/login.php?m&amp;next=http%3A%2F%2Fm.facebook.com%2Fhome.php", "HTTP/1.0", vbNullString, 0, lFlags, 0)
    
            If hHttpOpenRequest Then
    
                sBuffer = "email=" & Unicode2UTF8(sMail) & "&pass=" & Unicode2UTF8(sPass) & "&login=Log in"
    
                bResult = HttpSendRequest(hHttpOpenRequest, vbNullString, 0, ByVal sBuffer, Len(sBuffer))
            
                If bResult Then
                    sBuffer = vbNullString
                    
                    Do
                        sReadBuffer = vbNullString
                        bResult = InternetReadFile(hHttpOpenRequest, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
                        sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
                        If Not CBool(lNumberOfBytesRead) Then Exit Do
                    Loop
                    
                     If CBool(InStr(sBuffer, "/home.php?refid=7") > 0) Then
                        LogIn = True
                    End If
                End If
            
                Call InternetCloseHandle(hHttpOpenRequest)
            End If
            
            Call InternetCloseHandle(hInternetConnect)
            
        End If
        
        Call InternetCloseHandle(hInternetOpen)
    
    End If
End Function


Public Function IsSomeUserLogin() As Boolean
    Dim sBuffer  As String
    sBuffer = GetCode("http://m.facebook.com/home.php")
    
    If CBool(InStr(sBuffer, "/home.php?refid=7") > 0) Then
        IsSomeUserLogin = True
    End If
End Function


Public Function PublishComent(ByVal sPostFormId As String, ByVal sFb_dtsg As String, ByVal sComent As String) As Boolean
    Dim hInternetOpen           As Long
    Dim hInternetConnect        As Long
    Dim hHttpOpenRequest        As Long
    Dim bResult                 As Boolean
    Dim sReadBuffer             As String * 1024
    Dim sBuffer                 As String
    Dim lNumberOfBytesRead      As Long

    hInternetOpen = InternetOpen(USER_AGENT, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
    
    'InternetSetOption hInternetOpen, INTERNET_OPTION_CONNECT_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_RECEIVE_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_SEND_TIMEOUT, TIME_OUT, 4

    hInternetConnect = InternetConnect(hInternetOpen, "m.facebook.com", INTERNET_DEFAULT_HTTPS_PORT, vbNullString, "HTTP/1.1", INTERNET_SERVICE_HTTP, 0, 0)

    hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "POST", "/a/home.php?refid=7", "HTTP/1.0", vbNullString, 0, lFlags, 0)

    sBuffer = "fb_dtsg=" & sFb_dtsg & "&post_form_id=" & sPostFormId & "&charset_test=%E2%82%AC%2C%C2%B4%2C%E2%82%AC%2C%C2%B4%2C%E6%B0%B4%2C%D0%94%2C%D0%84&status=" & Unicode2UTF8(sComent) & "&update=Compartir"


    PublishComent = HttpSendRequest(hHttpOpenRequest, vbNullString, 0, ByVal sBuffer, Len(sBuffer))
    
    'sBuffer = vbNullString
    
    'Do
    '    sReadBuffer = vbNullString
    '    bResult = InternetReadFile(hHttpOpenRequest, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
    '    sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
    '    If Not CBool(lNumberOfBytesRead) Then Exit Do
    'Loop
    
     'If CBool(InStr(sBuffer, "/home.php?refid=7") > 0) Then
        'MsgBox UTF82Unicode(MidText(sBuffer, "(<a href=" & Chr$(34) & "</a> (", ")"))
        'LogIn = UTF82Unicode(MidText(sBuffer, "(<a href=" & Chr$(34) & "</a> (", ")"))
     '   LogIn = True
    'End If
        
    Call InternetCloseHandle(hHttpOpenRequest)
    Call InternetCloseHandle(hInternetConnect)
    Call InternetCloseHandle(hInternetOpen)
    
End Function

Public Function GetUserName(ByVal UserID As String) As String
    Dim sBuffer As String
    Dim sUser As String
    sBuffer = GetCode("https://graph.facebook.com/" & UserID)
    sUser = MidText(sBuffer, Chr$(34) & "name" & Chr$(34) & ": " & Chr$(34), Chr$(34) & ",")
    If sUser = vbNullString Then sUser = MidText(sBuffer, Chr$(34) & "name" & Chr$(34) & ":" & Chr$(34), Chr$(34) & ",")
    GetUserName = DecodeJSON(sUser)
End Function


Public Function GetIDAndFormID(ByRef sID As String, ByRef sFormID As String, ByRef sFb_dtsg As String) As Boolean
    Dim hInternetOpen           As Long
    Dim hInternetConnect        As Long
    Dim hHttpOpenRequest        As Long
    Dim bResult                 As Boolean
    Dim sReadBuffer             As String * 1024
    Dim sBuffer                 As String
    Dim lNumberOfBytesRead      As Long
    Dim bDoLoop                 As Boolean
    Dim lPos                    As Long
    
    hInternetOpen = InternetOpen(USER_AGENT, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)

    'InternetSetOption hInternetOpen, INTERNET_OPTION_CONNECT_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_RECEIVE_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_SEND_TIMEOUT, TIME_OUT, 4

    hInternetConnect = InternetConnect(hInternetOpen, "m.facebook.com", INTERNET_DEFAULT_HTTPS_PORT, vbNullString, "HTTP/1.1", INTERNET_SERVICE_HTTP, 0, 0)
    hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "GET", "/upload.php?refid=0", "HTTP/1.0", vbNullString, 0, lFlags, 0)
    
    bResult = HttpAddRequestHeaders(hHttpOpenRequest, HEADER, Len(HEADER), HTTP_ADDREQ_FLAG_REPLACE Or HTTP_ADDREQ_FLAG_ADD)
    bResult = HttpSendRequest(hHttpOpenRequest, vbNullString, 0, vbNullString, 0)
   
    bDoLoop = True
    While bDoLoop
        sReadBuffer = vbNullString
        bResult = InternetReadFile(hHttpOpenRequest, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
        If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
    Wend
    
    
    Call InternetCloseHandle(hHttpOpenRequest)
    Call InternetCloseHandle(hInternetConnect)
    
    lPos = InStr(sBuffer, """id""")

    If lPos > 0 Then
        sID = Mid(sBuffer, lPos + 12)
        sID = Left(sID, InStr(sID, Chr$(34)) - 1)
    End If
    
    
    lPos = InStr(sBuffer, "post_form_id")
    
    If lPos > 0 Then
        sFormID = Mid(sBuffer, lPos + 21)
        sFormID = Left(sFormID, InStr(sFormID, Chr$(34)) - 1)
    End If
    
    lPos = InStr(sBuffer, "fb_dtsg")
    If lPos > 0 Then
        sFb_dtsg = Mid(sBuffer, lPos + 16)
        sFb_dtsg = Left(sFb_dtsg, InStr(sFb_dtsg, Chr$(34)) - 1)
    End If

    
    Debug.Print sID, sFormID, sFb_dtsg
    If Len(sID) > 0 And Len(sFormID) > 0 And Len(sFb_dtsg) > 0 Then
        GetIDAndFormID = True
    End If
    
    bResult = InternetCloseHandle(hHttpOpenRequest)
    bResult = InternetCloseHandle(hInternetConnect)
    bResult = InternetCloseHandle(hInternetOpen)
End Function


Public Function GetAlbums() As String
    Dim i                   As Long
    Dim sHTML               As String
    Dim sName               As String
    Dim sParse()            As String

    sHTML = GetCode("http://m.facebook.com/photos.php")
    
    sParse = Split(sHTML, "set=a.") '"/album.php?aid="
    If UBound(sParse) > 0 Then
        ReDim tAlbum(0 To UBound(sParse) - 1)
        For i = 0 To UBound(sParse) - 1
            tAlbum(i).sID = MidText(sParse(i + 1), ".", ".")
            'tAlbum(i).sID = Left$(sParse(i + 1), InStr(sParse(i + 1), "&") - 1)
            tAlbum(i).sName = UTF82Unicode(MidText(sParse(i + 1), "<span>", "</span>"))
            GetAlbums = GetAlbums & tAlbum(i).sName & DELIMITER & tAlbum(i).sID & DELIMITER
        Next
    Else
        GetAlbums = "[NONE]"
    End If
    
End Function


Public Sub AddImage(ByRef sBuff As String, ByVal sControlName As String, ByVal sPath As String)
    
    Dim FileName            As String
    Dim FileType            As String
    Dim iFileNum            As Integer
    Dim lFileLen            As Long
    Dim StrFile             As String
    Dim OutArr()            As Byte
    Dim ImageResizing       As Long
    Dim ImageCompress       As Long
        
    FileName = Right(sPath, Len(sPath) - InStrRev(sPath, "\"))
    FileType = Right(FileName, Len(FileName) - InStrRev(FileName, "."))

    sBuff = sBuff & "--" & BOUNDARY & vbCrLf
    sBuff = sBuff & "Content-Disposition: form-data; name=" & Chr$(34) & sControlName & Chr$(34) & "; filename=" & Chr$(34) & FileName & Chr$(34) & vbCrLf
    sBuff = sBuff & "Content-Type: image/" & FileType & vbCrLf & vbCrLf

    'iFileNum = FreeFile
    'Open sPath For Binary As #iFileNum  'Access Read
    '    lFileLen = LOF(iFileNum)
    '    StrFile = String(lFileLen, 0)
    '    Get #iFileNum, 1, StrFile
    'Close #iFileNum
    
    ImageResizing = mdlINI.ReadData("IMAGE", "RESIZING", 720)
    ImageCompress = 100 - mdlINI.ReadData("IMAGE", "COMPRESSION", 25)
    
    If ResizeImageToStreamJPG(sPath, ImageResizing, ImageCompress, OutArr) Then
        StrFile = String(UBound(OutArr) + 1, 0)
        CopyMemory ByVal StrFile, OutArr(0), Len(StrFile)
        sBuff = sBuff & StrFile & vbCrLf
    End If
    
End Sub


Public Sub AddElemnt(ByRef sBuff As String, ByVal sName As String, ByVal sValue As String)
    sBuff = sBuff & "--" & BOUNDARY & vbCrLf
    sBuff = sBuff & "content-Disposition: form-data; name=" & Chr$(34) & sName & Chr$(34) & vbCrLf & vbCrLf & sValue & vbCrLf
End Sub


Public Function MidText(ByVal strText As String, ByVal Find1 As String, ByVal Find2 As String, Optional ByVal lStart As Long = 1, Optional ByVal Compare As VbCompareMethod = vbBinaryCompare) As String
    Dim lRet As Long, sRet As String
    lRet = InStr(lStart, strText, Find1, Compare)
    If lRet Then
        sRet = Mid$(strText, lRet + Len(Find1))
        lRet = InStr(1, sRet, Find2, Compare)
        If lRet Then
            MidText = Left$(sRet, lRet - 1)
        End If
    End If
End Function


Public Function CreateAlbum(ByVal sID As String, ByVal sPostFormId As String, ByVal sFb_dtsg As String, ByVal sName As String, ByVal slocation As String, ByVal sPrivacy As String) As String
    Dim hInternetOpen           As Long
    Dim hInternetConnect        As Long
    Dim hHttpOpenRequest        As Long
    Dim sHeader                 As String
    Dim bResult                 As Boolean
    Dim lpszPostData            As String
    Dim lPostDataLen            As Long
    Dim sBuffer                 As String
    Dim sReadBuffer             As String * 2048
    Dim bDoLoop                 As Boolean
    Dim lNumberOfBytesRead      As Long
    Dim sBuff                   As String
    Dim lTimeOut                As Long
    'Dim lFlags                 As Long
    Dim lPos                    As Long
    'Dim sPostFormId            As String
    'Dim id                     As String

    hInternetOpen = InternetOpen(USER_AGENT, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)

    'InternetSetOption hInternetOpen, INTERNET_OPTION_CONNECT_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_RECEIVE_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_SEND_TIMEOUT, TIME_OUT, 4

    hInternetConnect = InternetConnect(hInternetOpen, "www.facebook.com", INTERNET_DEFAULT_HTTPS_PORT, vbNullString, "HTTP/1.1", INTERNET_SERVICE_HTTP, 0, 0)
    hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "POST", "/albums/create.php", "HTTP/1.0", vbNullString, 0, lFlags, 0)

    sBuff = "post_form_id=" & sPostFormId & _
            "&fb_dtsg=" & sFb_dtsg & _
            "&id=" & sID & _
            "&create=1&simple=1" & _
            "&name=" & Unicode2UTF8(sName) & _
            "&location=" & Unicode2UTF8(slocation) & _
            "&UIPrivacyWidget%5B0%5D=" & sPrivacy & _
            "&privacy_data%5B0%5D%5Bvalue%5D=" & sPrivacy & _
            "&privacy_data%5B0%5D%5Bfriends%5D=0&privacy_data%5B0%5D%5Blist_anon%5D=0&privacy_data%5B0%5D%5Blist_x_anon%5D=0" & vbCrLf
    
    bResult = HttpSendRequest(hHttpOpenRequest, vbNullString, 0, ByVal sBuff, Len(sBuff))

    bDoLoop = True
    While bDoLoop
        sReadBuffer = vbNullString
        bResult = InternetReadFile(hHttpOpenRequest, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
        If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
    Wend
    
    CreateAlbum = MidText(sBuffer, "&aid=", "&")
    
    bResult = InternetCloseHandle(hHttpOpenRequest)
    bResult = InternetCloseHandle(hInternetConnect)
    bResult = InternetCloseHandle(hInternetOpen)
End Function


Public Function UploadPhotoFacebook(ByVal sAlbum As String, ByVal sPath As String) As Boolean
    Dim hInternetOpen               As Long
    Dim hInternetConnect            As Long
    Dim hHttpOpenRequest            As Long
    Dim sHeader                     As String
    Dim bResult                     As Boolean
    Dim lpszPostData                As String
    Dim lPostDataLen                As Long
    Dim sBuffer                     As String
    Dim sReadBuffer                 As String * 2048
    Dim bDoLoop                     As Boolean
    Dim lNumberOfBytesRead          As Long
    Dim sBuff                       As String
    Dim lTimeOut                    As Long
    'Dim lFlags                     As Long
    Dim lPos                        As Long
    Dim sPostFormId                 As String
    Dim ID                          As String
    Dim LenBuff                     As Long

    hInternetOpen = InternetOpen(USER_AGENT, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)

    'InternetSetOption hInternetOpen, INTERNET_OPTION_CONNECT_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_RECEIVE_TIMEOUT, TIME_OUT, 4
    'InternetSetOption hInternetOpen, INTERNET_OPTION_SEND_TIMEOUT, TIME_OUT, 4

    hInternetConnect = InternetConnect(hInternetOpen, "upload.facebook.com", INTERNET_DEFAULT_HTTP_PORT, vbNullString, "HTTP/1.1", INTERNET_SERVICE_HTTP, 0, 0)
    
    'hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "POST", "/mobile_upload.php", "HTTP/1.0", vbNullString, 0, 0, 0)
    hHttpOpenRequest = HttpOpenRequest(hInternetConnect, "POST", "/photos_upload.php", "HTTP/1.0", vbNullString, 0, 0, 0)
    
    bResult = HttpAddRequestHeaders(hHttpOpenRequest, HEADER, Len(HEADER), HTTP_ADDREQ_FLAG_REPLACE Or HTTP_ADDREQ_FLAG_ADD)

    sHeader = HEADER & "Content-Type: multipart/form-data; boundary=" & BOUNDARY & vbCrLf
    bResult = HttpAddRequestHeaders(hHttpOpenRequest, sHeader, Len(sHeader), HTTP_ADDREQ_FLAG_REPLACE Or HTTP_ADDREQ_FLAG_ADD)


    sBuff = vbNullString
    AddElemnt sBuff, "charset_test", Unicode2UTF8(",,,,?,?,?")
    AddElemnt sBuff, "fb_dtsg", "9ZqD5"
    AddElemnt sBuff, "post_form_id", m_sPostFormID
    AddElemnt sBuff, "return", "editphoto.php?aid=" & sAlbum
    AddElemnt sBuff, "aid", sAlbum
    AddElemnt sBuff, "id", m_sID
    AddElemnt sBuff, "add", 1
    AddElemnt sBuff, "return", "/editphoto.php?aid=" & sAlbum
    AddImage sBuff, "file1", sPath
    AddElemnt sBuff, "qn", "1303695553"
    AddElemnt sBuff, "simple", "1"
    sBuff = sBuff & "--" & BOUNDARY & "--" & vbCrLf
'--------------------------------------------------------------


    bResult = HttpSendRequest(hHttpOpenRequest, vbNullString, 0, ByVal sBuff, Len(sBuff))

    If bResult Then

        sBuffer = String(200, 0)
        LenBuff = Len(sBuffer)
        
        If HttpQueryInfo(hHttpOpenRequest, HTTP_QUERY_STATUS_CODE, ByVal sBuffer, LenBuff, 0) Then
            UploadPhotoFacebook = Left$(sBuffer, InStr(sBuffer, Chr$(0))) = 200
        End If
    
    End If
    
    bDoLoop = True
    While bDoLoop
        sReadBuffer = vbNullString
        bResult = InternetReadFile(hHttpOpenRequest, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        sBuffer = sBuffer & Left$(sReadBuffer, lNumberOfBytesRead)
        If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
    Wend

    bResult = InternetCloseHandle(hHttpOpenRequest)
    bResult = InternetCloseHandle(hInternetConnect)
    bResult = InternetCloseHandle(hInternetOpen)
    
End Function
